import { ContractTypeDefinitions, defineContractExport, defineContracts } from "@dunemask/vix/util";
import * as y from "yup";
const antiRequired = y.string().test("insecure-exposure", "Insecure Exposure", (value) => !value);
// ====================================== Reused Contracts ======================================

// ====================================== Response Contracts ======================================

export const DatabaseContractRes = defineContractExport("CDatabaseContractRes", {
  User: y.object({
    id: y.string().required(),
    username: y.string().required(),
    email: y.string().nullable(),
    hash: antiRequired,
    rolePolicyId: y.string().required(),
  }),
  Project: y.object({
    id: y.string().required(),
    slug: y.string().required(),
    parentProject: y.string().required(),
    name: y.string().nullable(),
  }),
});

// ====================================== Request Contracts ======================================

export const DatabaseContractReq = defineContractExport("CDatabaseContractReq", {});

// ====================================== Combined Declarations ======================================

export const DatabaseContract = defineContractExport("CDatabaseContract", { ...DatabaseContractRes, ...DatabaseContractReq });

// ====================================== Type Declarations ======================================

export type CDatabaseContractRes = ContractTypeDefinitions<typeof DatabaseContractRes>;
export type CDatabaseContractReq = ContractTypeDefinitions<typeof DatabaseContractReq>;
export type CDatabaseContract = ContractTypeDefinitions<typeof DatabaseContract>;
