import { ContractTypeDefinitions, defineContractExport, defineContracts } from "@dunemask/vix/util";
import { AuthorityType } from "@prisma/client";
import * as y from "yup";
const antiRequired = y.string().test("insecure-exposure", "Insecure Exposure", (value) => !value);
// ====================================== Reused Contracts ======================================

// ====================================== Response Contracts ======================================

export const RolePolicyContractRes = defineContractExport("CRolePolicyContractRes", {});

// ====================================== Request Contracts ======================================

export const RolePolicyContractReq = defineContractExport("CRolePolicyContractReq", {
  Create: y.object({
    authority: y.string().required(),
    authorityType: y.string().oneOf(Object.values(AuthorityType)),
    projectId: y.string().required(),
    name: y.string().required(),
    policies: y.array(y.string().required()).required(),
  }),
});

// ====================================== Combined Declarations ======================================

export const RolePolicyContract = defineContractExport("CRolePolicyContract", {
  ...RolePolicyContractRes,
  ...RolePolicyContractReq,
});

// ====================================== Type Declarations ======================================

export type CRolePolicyContractRes = ContractTypeDefinitions<typeof RolePolicyContractRes>;
export type CRolePolicyContractReq = ContractTypeDefinitions<typeof RolePolicyContractReq>;
export type CRolePolicyContract = ContractTypeDefinitions<typeof RolePolicyContract>;
