import { ContractTypeDefinitions, defineContractExport } from "@dunemask/vix/util";
import * as y from "yup";
// ====================================== Reused Contracts ======================================

// ====================================== Response Contracts ======================================

export const UserContractRes = defineContractExport("CUserContractRes", {});

// ====================================== Request Contracts ======================================

export const UserContractReq = defineContractExport("CUserContractReq", {
  Create: y.object({
    projectId: y.string().required(),
    username: y.string().required(),
    email: y.string(),
    hash: y.string().required(),
    rolePolicyId: y.string().required(),
  }),
});

// ====================================== Combined Declarations ======================================

export const UserContract = defineContractExport("CUserContract", { ...UserContractRes, ...UserContractReq });

// ====================================== Type Declarations ======================================

export type CUserContractRes = ContractTypeDefinitions<typeof UserContractRes>;
export type CUserContractReq = ContractTypeDefinitions<typeof UserContractReq>;
export type CUserContract = ContractTypeDefinitions<typeof UserContract>;
