export enum IAMResource {
  Root = "root",
  Admin = "admin",
  User = "user",
  CairoProjectRoot = "cairo-project-root",
}

export enum ManagementResource {
  ManageAdmin = "manage-admin",
  ManageUser = "manage-user",
  ManageProject = "manage-project",
}

export enum OtherResource {
  Random = "Random",
}

type ResourceEnums<T extends Record<string, string>> = T[keyof T];
export const Resource = { ...IAMResource, ...ManagementResource, ...OtherResource };
export type Resource = ResourceEnums<typeof Resource>;
