import { Box } from "@chakra-ui/react";
import MainMenu, { useMainMenu } from "./components/MainMenu";
import Portal from "./Portal";
import { ToastContainer } from "react-toastify";

export default function Viewport() {
  const [minified, toggleMinified, drawerWidth] = useMainMenu();
  return (
    <Box>
      <MainMenu minified={minified} toggleMinified={toggleMinified} width={drawerWidth} />
      <Box width={`calc(100% - ${drawerWidth})`} marginLeft={drawerWidth}>
        <Portal />
      </Box>
      <ToastContainer />
    </Box>
  );
}
