import { apiRequest, ApiRequestArgs } from "@dunemask/vix/bridge";
import { getAuthHeader } from "@src/ctx/AuthContext";

export async function authenticatedApiRequest<K = any>(apiRequestArgs: ApiRequestArgs): Promise<K> {
  const extraHeaders = apiRequestArgs.extraHeaders ?? {};
  const authHeaders = getAuthHeader();
  apiRequestArgs.extraHeaders = { ...extraHeaders, ...authHeaders };
  return apiRequest(apiRequestArgs);
}
